#include "reconst.h"
#include <math.h>
#include <stdio.h>
#include <iostream>
#include "cv.h"
#include "opencv2/core/core.hpp"
#include "opencv2/features2d/features2d.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/video/tracking.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/imgproc/imgproc.hpp"



#include "stdafx.h"
#include <math.h>
using namespace std;
using namespace cv;




point3D reconst(Foto foto1, Foto foto2, int x1, int y1, int x2,int y2){
	double a11 = cos(foto1.alpha)*cos(foto1.kappa) - sin(foto1.alpha) * sin(foto1.omega) * sin(foto1.kappa);
	double a12 = - cos(foto1.alpha) *sin(foto1.kappa) - sin(foto1.alpha) * sin(foto1.omega) * sin(foto1.kappa);
	double a13 = - sin ( foto1.alpha) * cos(foto1.omega);
	double b11 = cos (foto1.omega) * sin (foto1.kappa);
	double b12 = cos ( foto1.omega) * cos (foto1.kappa);
	double b13 = - sin (foto1.omega);
	double c11 = sin(foto1.alpha)*cos(foto1.kappa) + cos(foto1.alpha) * sin(foto1.omega) * sin(foto1.kappa);
	double c12 = - sin(foto1.alpha) *sin(foto1.kappa) + cos(foto1.alpha) * sin(foto1.omega) * cos(foto1.kappa);
	double c13 = cos( foto1.alpha) * cos(foto1.omega);
	double a21 = cos(foto2.alpha)*cos(foto2.kappa) - sin(foto2.alpha) * sin(foto2.omega) * sin(foto2.kappa);
	double a22 = - cos(foto2.alpha) *sin(foto2.kappa) - sin(foto2.alpha) * sin(foto2.omega) * sin(foto2.kappa);
	double a23 = - sin ( foto2.alpha) * cos(foto2.omega);
	double b21 = cos (foto2.omega) * sin (foto2.kappa);
	double b22 = cos ( foto2.omega) * cos (foto2.kappa);
	double b23 = - sin (foto2.omega);
	double c21 = sin(foto2.alpha)*cos(foto2.kappa) + cos(foto2.alpha) * sin(foto2.omega) * sin(foto2.kappa);
	double c22 = - sin(foto2.alpha) *sin(foto2.kappa) + cos(foto2.alpha) * sin(foto2.omega) * cos(foto2.kappa);
	double c23 = cos( foto2.alpha) * cos(foto2.omega);

	double X1 = a11 * x1 + a12 * y1 - a13 * foto1.focus;
	double Y1 = b11 * x1 + b12 * y1 - b13 * foto1.focus;
	double Z1 = c11 * x1 + c12 * y1 - c13 * foto1.focus;
	double X2 = a21 * x2 + a22 * y1 - a23 * foto1.focus;
	double Y2 = b21 * x2 + b22 * y1 - b23 * foto1.focus;
	double Z2 = c21 * x2 + c22 * y1 - c23 * foto1.focus;
	
	double B_X = abs(foto1.X - foto2.X);
	double B_Y = abs(foto1.Y - foto2.Y);
	double B_Z = abs(foto1.Z - foto2.Z);

	double N = (B_X * Y2 - B_Y *X2)/(X1*Y2 - Y1 * X2);
	double X = foto1.X + N * X1;
	double Y = foto1.Y + N * Y1;
	double Z = foto1.Z + N * Z1;
	point3D coord;
	coord.x = X;
	coord.y = Y;
	coord.z = Z;
	return coord;
}



/*
void reconst2(points* coordA, points* coordB, int length, points centrA){
	points* res = new points[length];
	
	/*for(int i = 0; i < 6; ++i){
	float C = 2400 / 8.4;
	float pi = 3.141592653;
	float r = coordA[i].x/coordB[i].x;
	res[i].x = C * (1/2 + 1/(r - 1));
	res[i].y = C /( coordB[i].x/1600 * r * tan(pi/180*87));
	res[i].z = coordA[i].y/1200*tan(pi/180*87);
	}

	for(int i = 0; i < 6; ++i){
	float C = 200 / 0.1;
	float pi = 3.141592653;
	float r = coordA[i].x/coordB[i].x;
	res[i].x = C * (1/2 + 1/(r - 1));
	res[i].y = C /( coordB[i].x/2304 * r * tan(pi/180*71.5));
	res[i].z = coordA[i].y/2304*tan(pi/180*71.5);
	}
}
*/