#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"
#include <stdlib.h>
#include <stdio.h>
#include "morphology2.h"
#include "contours.h"

using namespace cv;



int element_shape = MORPH_RECT;

Mat morhphology2(Mat src)
{
	int an = 5;
	Mat dst2;
    Mat element = getStructuringElement(element_shape, Size(an*2+1, an*2+1), Point(an, an) );
	Mat dst1;
	boxFilter(src,dst1,src.depth(),Size(3,3), Point(-1, -1));
	//bilateralFilter(src2, dst1, 5, 300,300);
    erode(dst1, dst2, element);
    for( int y = 0; y < dst2.rows; y++ )
    { 
		for( int x = 0; x < dst2.cols; x++ )
         {
			 for( int c = 0; c < 3; c++ )
              {
				  dst2.at<Vec3b>(y,x)[c] =
				  saturate_cast<uchar>(1.4*( dst2.at<Vec3b>(y,x)[c] ));
			  }
		 }
    }
	return dst2;
}
